from distparser import WORLD_SIZE

import torch
class BatchData:
    '''
         Args:
            batch_size: the number of sampled node
            nids: the real id of sampled nodes and their neighbours 
            edge_index: the edge between nids, the nodes' id is the index of BatchData
            x: nodes' feature
            y: 
            eids: the edge id in subgraph of edge_index
            train_mask
            val_mask
            test_mask
    '''
    def __init__(self,nids,edge_index,roots=None,x=None,y=None,eids=None,train_mask=None,val_mask=None,test_mask=None):
        self.batch_size=roots.size(0)
        self.roots=roots
        self.nids=nids
        self.edge_index=edge_index
        self.x=x
        self.y=y
        self.eids=eids
        self.train_mask=train_mask
        self.val_mask=val_mask
        self.test_mask=test_mask

    def _check_with_graph(self,graph1,graph2):
        for i,id in enumerate(self.nids):
            if(id >= graph1.partptr[0] and id < graph1.partptr[1]):
                real_x = graph1.select_attr(graph1.get_localId_by_partitionId(0,torch.tensor(id)))
            else:
                real_x = graph2.select_attr(graph2.get_localId_by_partitionId(1,torch.tensor(id)))

    def __repr__(self):
        return "BatchData(batch_size = {},roots = {} , \
            nides = {} , edge_index = {} , x= {}, \
                y ={})".format(self.batch_size,self.roots.__repr__,
                               self.nids.__repr__,
                               self.edge_index.__repr__,
                               self.train_mask.__repr__,
                               self.x.__repr__,self.y.__repr__) 

    def to(self,device = 'cpu'):
        if device == 'cpu':
            return
        else:
            self.y.to(device)
            self.edge_index.to(device)
            self.roots.to(device)
            self.nids.to(device)
            self.eids.to(device)
            